package lecture_en;

import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

/** Przyklad zastosowania DOM.
 * @author Patryk Czarnik
 */
public class StaffDOM {
  public static void main(String[] args) {
    if(args.length < 1) {
      System.out.println("Too few args");
      return;
    }

    int result = 0;
    try {
      DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      DocumentBuilder builder = factory.newDocumentBuilder();
      Document doc = builder.parse(args[0]);
      
      
      Node cur = doc.getFirstChild();
      while(cur.getNodeType() != Node.ELEMENT_NODE)
        cur = cur.getNextSibling();
      cur = cur.getFirstChild();
      while(cur != null) {
        if(cur.getNodeType() == Node.ELEMENT_NODE) {
          Node attr = cur.getAttributes().getNamedItem("position");
          if(attr != null && "specialist".equals(attr.getNodeValue())) {
            result += processPerson(cur);
          }
        }
        cur = cur.getNextSibling();
      }
    } catch (DOMException e) {
      e.printStackTrace();
    } catch (FactoryConfigurationError e) {
      e.printStackTrace();
    } catch (ParserConfigurationException e) {
      e.printStackTrace();
    } catch (SAXException e) {
      e.printStackTrace();
    } catch (IOException e) {
      e.printStackTrace();
    }
    System.out.println("Result: "+result);
  }
  
  private static int processPerson(Node person) {
    Node cur = person.getFirstChild();
    while(cur != null) {
      if(cur.getNodeType() == Node.ELEMENT_NODE
          && "salary".equals(cur.getNodeName())) {
        StringBuffer buf = new StringBuffer();
        Node child = cur.getFirstChild();
        while(child != null) {
          if(child.getNodeType() == Node.TEXT_NODE)
            buf.append(child.getNodeValue());
          child = child.getNextSibling();
        }
        return Integer.parseInt(buf.toString());
      }
      cur = cur.getNextSibling();
    }
    return 0;  // no salary found
  }
}
