package lecture_en;
/*
 * Created on 2004-11-29
 */
import java.io.IOException;

import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

/**
 * @author Patryk Czarnik
 */
public class StaffSAX {
  public static void main(String[] args) {
    if(args.length < 1) {
      System.out.println("Too few args");
      return;
    }

    try {
    	XMLReader reader = XMLReaderFactory.createXMLReader();
    			
      SAXParserFactory factory = SAXParserFactory.newInstance();
      //factory.setValidating(true);
      SAXParser parser = factory.newSAXParser();
      
      StaffHandler handler = new StaffHandler();
      parser.parse(args[0], handler);

      System.out.println("Result: "+handler.getResult());
    } catch (FactoryConfigurationError e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    } catch (SAXException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    } catch (ParserConfigurationException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    } catch (IOException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
  }
  
  private static class StaffHandler extends DefaultHandler {
	enum State {EXTERNAL, PERSON, SALARY};

    private int result = 0;
    private State state = State.EXTERNAL;
    private StringBuffer buf;
    
    public int getResult() {
      return result;
    }
   
    public void startElement(String uri, String localName, String qName,
        Attributes attributes) throws SAXException {
      if("person".equals(qName)) {
        String attrVal = attributes.getValue("position");
        if("specialist".equals(attrVal))
          state = State.PERSON;
      } else if("salary".equals(qName)) {
        if(state == State.PERSON) {
          state = State.SALARY;
          buf = new StringBuffer();
        }
      }
    }

    public void endElement(String uri, String localName, String qName)
    throws SAXException {
      if("person".equals(qName)) {
        if(state == State.PERSON) {
          state = State.EXTERNAL;
        }
      } else if("salary".equals(qName)) {
        if(state == State.SALARY) {
          state = State.PERSON;
          try {
            result += Integer.parseInt(buf.toString());
          } catch (NumberFormatException e) {
          }
        }
      }
    }
    public void characters(char[] ch, int start, int length)
        throws SAXException {
      if(state == State.SALARY)
        buf.append(ch, start, length);
    }
  }
}
